<?php
/*
* @package		AceSEF
* @subpackage	FLEXIcontent
* @copyright	2009-2010 JoomAce LLC, www.joomce.net
* @license		http://www.joomace.net/company/license
*/

// No Permission
defined('_JEXEC') or die('Restricted access');

class AceSEF_com_flexicontent extends AcesefExtension {
	
	function beforeBuild(&$uri) {
		if (!is_null($uri->getVar('id'))){
			AcesefURI::fixUriVar($uri, 'id');
		}
		
		if (!is_null($uri->getVar('view') && $uri->getVar('view') == 'items' && (is_null($uri->getVar('cid')) || $uri->getVar('cid') == 0)) && !is_null($uri->getVar('id'))){
			$id = $uri->getVar('id');
			$catid = self::_getItemCatId(intval($id));
			if (!empty($catid)){
				$uri->setVar('cid', $catid);
			}
		}
		
		$route_helper = JPATH_ROOT.DS.'components'.DS.'com_flexicontent'.DS.'helpers'.DS.'route.php';
		if (($this->params->get('smart_itemid', '1') == '2') && file_exists($route_helper) && !is_null($uri->getVar('view')) && !is_null($uri->getVar('cid'))) {
			require_once($route_helper);
			
			if (!class_exists('FlexicontentHelperRoute')) {
				return;
			}
			
			if (!method_exists('FlexicontentHelperRoute', '_findCategory')) {
				return;
			}
			
			if (!method_exists('FlexicontentHelperRoute', '_findItem')) {
				return;
			}
			
			$cid = $uri->getVar('cid');
			
			if ($uri->getVar('view') == 'category') {
				$needles = array('category' => (int) $cid);
		
				$item = FlexicontentHelperRoute::_findCategory($needles);
				if (!empty($item)) {
					$uri->setVar('Itemid', $item->id);
				}
			}
			
			if ($uri->getVar('view') == 'items' && !is_null($uri->getVar('id'))) {
				$id = $uri->getVar('id');
				$needles = array('items' => (int) $id, 'category' => (int) $cid);
		
				$item = FlexicontentHelperRoute::_findItem($needles);
				if (!empty($item)) {
					$uri->setVar('Itemid', $item->id);
				}
			}
		}
    }
	
	function _getItemCatId($id) {
		static $cache = array();
		
		if (!isset($cache[$id])) {
			if ($this->AcesefConfig->cache_instant == 1) {
				$rows = AceDatabase::loadRowList("SELECT id, catid FROM #__content");
				foreach ($rows as $row) {
					$cache[$row[0]] = $row[1];
				}
			} else {
				$cache[$id] = AceDatabase::loadResult("SELECT catid FROM #__content WHERE id = {$id}");
			}
		}
		
		if (!isset($cache[$id])) {
			$cache[$id] = "";
		}
		
		return $cache[$id];
    }
	
	function catParam($vars, $real_url) {
        extract($vars);
		
		if (isset($view)) {
            switch($view) {
                case 'category':
					if (!empty($cid)) {
						parent::categoryParams($cid, 1, $real_url);
					}
                    break;
				case 'items':
					if (!empty($cid)) {
						parent::categoryParams($cid, 0, $real_url);
					}
					break;
            }
        }
	}
	
	function build(&$vars, &$segments, &$do_sef, &$metadata, &$item_limitstart) {
        extract($vars);
		
		$cat_suffix 	= $this->params->get('cat_suffix', '1');
		$default_index	= $this->params->get('default_index', '');
		
		if (isset($cid)){
			$segments = array_merge($segments, self::_getCategory(intval($cid)));
			unset($vars['cid']);
		}
		
		if (isset($view)) {
			switch($view) {
				case 'category':
					if ($cat_suffix == '1' && $default_index == ''){
						$segments[] = "/";
					}
					
					if($default_index != ''){
						$segments[] = $default_index;
					}
					break;
				case 'items':
					if (isset($id)){
						$segments[] = self::_getItem(intval($id));
					}
					
					if (!empty($id) && $this->params->get('google_news', '1') != '1' && !empty($cid)) {
						$categories = $this->params->get('google_news_cats', 'all');
						
						$apply_gn = false;
						if ($categories == 'all') {
							$apply_gn = true;
						}
						elseif (is_array($categories) && in_array($cid, $categories)) {
							$apply_gn = true;
						}
						elseif ($categories == $cid) {
							$apply_gn = true;
						}
						
						if ($apply_gn) {
							$i = count($segments) - 1;
							$segments[$i] = self::_googleNews($segments[$i], intval($id));
						}
					}
					
					if (!empty($limitstart)) {
						$item_limitstart = true;
					}
					
					unset($vars['id']);
					break;
				case 'tags':
					$segments[] = JText::_('Tags');
					if (isset($id)){
						$segments[] = self::_getTag(intval($id));
						unset($vars['id']);
					}
					break;
				case 'favourites':
					$segments[] = JText::_('FLEXI_MY_FAVOURITES');
					break;
				default:
					$segments[] = $view;
					break;
			}
			unset($vars['view']);
		}
	
		if (!empty($task)){
			switch ($task){
				case 'weblink':
					if (!empty($cid)){
						$segments[] = self::_getContent(intval($cid));
						unset($vars['cid']);
					}
					
					if (!empty($fid)){
						$segments[] = self::_getField(intval($fid));
						unset($vars['fid']);
					}
					break;
				default:
					$segments[] = $task;
					break;
			}
			unset($vars['task']);
		}
		
		$metadata = parent::getMetaData($vars, $item_limitstart);
		
		unset($vars['limit']);
		unset($vars['limitstart']);
	}

	function _getCategory($id) {
		static $cache = array();
		
		if (!isset($cache[$id])) {
			$joomfish = $this->AcesefConfig->joomfish_trans_url ? ', id' : '';
			
			$cats = $this->params->get('category_inc', '3');
			$categories = array();
			$cat_title = array();
			$cat_desc = array();
			
			if ($cats == '1')
				$id = 0; // No cat to add
			while ($id > 0) {
				$row = AceDatabase::loadRow("SELECT title, alias, parent_id, description$joomfish FROM #__categories WHERE id =".$id);

				$name = (($this->params->get('categoryid_inc', '1') != '1') ? $id.'-' : '');
				if(parent::urlPart($this->params->get('category_part', 'global')) == 'title'){
					$name .= $row[0];
				} else {
					$name .= $row[1];
				}
				
				array_unshift($categories, $name);
				array_push($cat_title, $row[0]);
				$cat_desc[] = $row[3];
				
				$id = $row[2];
				if ($cats == '2')
					break; //  Only last cat
			}
			
			$cache[$id]['name'] = $categories;
			$cache[$id]['meta_title'] = $cat_title;
			$cache[$id]['meta_desc'] = $cat_desc;
		}
		
		$this->meta_title = $cache[$id]['meta_title'];
		if (!empty($cache[$id]['meta_desc'])) {
			$this->meta_desc = $cache[$id]['meta_desc'][0];
		}
		
		return $cache[$id]['name'];
    }

    function _getItem($id) {
		static $cache = array();
		
		if (!isset($cache[$id])) {
			$joomfish = $this->AcesefConfig->joomfish_trans_url ? ', id' : '';
			$row = AceDatabase::loadRow("SELECT title, alias, introtext, metadesc$joomfish FROM #__content WHERE id =".$id);

			$name = (($this->params->get('itemid_inc', '1') != '1') ? $id.'-' : '');
			if(parent::urlPart($this->params->get('item_part', 'global')) == 'title'){
				$name .= $row[0];
			} else {
				$name .= $row[1];
			}
			
			$cache[$id]['name'] = $name;
			$cache[$id]['meta_title'] = $row[0];
			$cache[$id]['meta_desc'] = $row[2];
		}
		
		array_unshift($this->meta_title, $cache[$id]['meta_title']);
		if (!empty($cache[$id]['meta_desc'])) {
			$this->meta_desc = $cache[$id]['meta_desc'];
		}
		
		return $cache[$id]['name'];
    }
	
	function _getTag($id){
		static $cache = array();
		
		if (!isset($cache[$id])) {
			$row = AceDatabase::loadRow('SELECT name, alias FROM #__flexicontent_tags WHERE id ='.$id);

			$name = (($this->params->get('tagid_inc', '1') != '1') ? $id.'-' : '' );
			if(parent::urlPart($this->params->get('tag_part', 'global')) == 'title'){
				$name .= $row[0];
			} else {
				$name .= $row[1];
			}
			
			$cache[$id]['name'] = $name;
			$cache[$id]['meta_title'] = $row[0];
		}
		
		$this->meta_title[] = $cache[$id]['meta_title'];
		
		return $cache[$id]['name'];
    }
	
	function _getContent($id){
		static $cache = array();
		
		if (!isset($cache[$id])) {
			$row = AceDatabase::loadRow('SELECT title, alias FROM #__content WHERE id ='.$id);
			
			$name = (($this->params->get('contentid_inc', '1') != '1') ? $id.'-' : '' );
			if(parent::urlPart($this->params->get('content_part', 'global')) == 'title'){
				$name .= $row[0];
			} else {
				$name .= $row[1];
			}
			
			$cache[$id]['name'] = $name;
		}
		return $cache[$id]['name'];
    }
	
	function _getField($id){
		static $cache = array();
		
		if (!isset($cache[$id])) {
			$row = AceDatabase::loadRow('SELECT label FROM #__flexicontent_fields WHERE id ='.$id);
			
			$name = (($this->params->get('fieldid_inc', '1') != '1') ? $id.'-' : '' ).$row[0];
			$cache[$id]['name'] = $name;
		}
		return $cache[$id]['name'];
    }
	
	function _googleNews($segments, $id) {
        $num = '';
        $add = $this->params->get('google_news', '1');

        if($add == '2') {
            // Article ID
            $digits = trim($this->params->get('google_news_digits', '3'));
            if(!is_numeric($digits)) {
                $digits = '3';
            }

            $num = sprintf('%0'.$digits.'d', $id);
        }
        else if($add == '3') {
            // Publish date
            $query = "SELECT `publish_up` FROM `#__content` WHERE `id` = '$id'";
            $time = AceDatabase::loadResult($query);
            $time = strtotime($time);

            $date = $this->params->get('google_news_dateformat', 'ddmm');

            $search = array('dd', 'd', 'mm', 'm', 'yyyy', 'yy');
            $replace = array(date('d', $time), date('j', $time), date('m', $time), date('n', $time), date('Y', $time), date('y', $time));
            $num = str_replace($search, $replace, $date);
        }

        if(!empty($num)) {
            $sep = $this->AcesefConfig->replacement_character;
            $where = $this->params->get('google_news_pos', '2');

            if($where == '2') {
                $segments = $segments.$sep.$num;
            } else {
                $segments = $num.$sep.$segments;
            }
        }

        return $segments;
    }

	function getCategoryList($query) {
		$params = JComponentHelper::getParams("com_flexicontent");
		
		$rows = AceDatabase::loadObjectList("SELECT id, title AS name, parent_id AS parent FROM #__categories WHERE section = '{$params->get('flexi_section', 0)}' ORDER BY title");
		return $rows;
	}
}
?>